<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "sales_analysis".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SalesAnalysis".
 *
 * Columns in table "sales_analysis" available as properties of the model,
 * followed by relations of table "sales_analysis" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property integer $account_id
 * @property string $user_comment
 * @property string $date_added
 *
 * @property Account $account
 * @property SalesAnalysisSetting[] $salesAnalysisSettings
 */
abstract class BaseSalesAnalysis extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'sales_analysis';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SalesAnalysis|SalesAnalysises', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, account_id', 'required'),
            array('account_id', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>256),
            array('user_comment, date_added', 'safe'),
            array('user_comment, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, account_id, user_comment, date_added', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'salesAnalysisSettings' => array(self::HAS_MANY, 'SalesAnalysisSetting', 'sales_analysis_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'account_id' => null,
            'user_comment' => Yii::t('app', 'User Comment'),
            'date_added' => Yii::t('app', 'Date Added'),
            'account' => null,
            'salesAnalysisSettings' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('user_comment', $this->user_comment, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
